#include "_gen/svc.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _salut_svc_channel_type_file_transfer_object_info;

struct _SalutSvcChannelTypeFileTransferClass {
    GTypeInterface parent_class;
    salut_svc_channel_type_file_transfer_list_file_transfers_impl list_file_transfers;
    salut_svc_channel_type_file_transfer_offer_file_impl offer_file;
    salut_svc_channel_type_file_transfer_accept_file_impl accept_file;
    salut_svc_channel_type_file_transfer_close_file_transfer_impl close_file_transfer;
    salut_svc_channel_type_file_transfer_get_local_unix_socket_path_impl get_local_unix_socket_path;
};

enum {
    SIGNAL_CHANNEL_TYPE_FILE_TRANSFER_NewFileTransfer,
    SIGNAL_CHANNEL_TYPE_FILE_TRANSFER_FileTransferStateChanged,
    SIGNAL_CHANNEL_TYPE_FILE_TRANSFER_FileTransferClosed,
    N_CHANNEL_TYPE_FILE_TRANSFER_SIGNALS
};
static guint channel_type_file_transfer_signals[N_CHANNEL_TYPE_FILE_TRANSFER_SIGNALS] = {0};

static void salut_svc_channel_type_file_transfer_base_init (gpointer klass);

GType
salut_svc_channel_type_file_transfer_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (SalutSvcChannelTypeFileTransferClass),
        salut_svc_channel_type_file_transfer_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "SalutSvcChannelTypeFileTransfer", &info, 0);
    }

  return type;
}

/**
 * salut_svc_channel_type_file_transfer_list_file_transfers_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * ListFileTransfers on interface org.freedesktop.Telepathy.Channel.Type.FileTransfer.
 */
static void
salut_svc_channel_type_file_transfer_list_file_transfers (SalutSvcChannelTypeFileTransfer *self,
    DBusGMethodInvocation *context)
{
  salut_svc_channel_type_file_transfer_list_file_transfers_impl impl = (SALUT_SVC_CHANNEL_TYPE_FILE_TRANSFER_GET_CLASS (self)->list_file_transfers);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_channel_type_file_transfer_implement_list_file_transfers:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the ListFileTransfers D-Bus method
 *
 * Register an implementation for the ListFileTransfers method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_channel_type_file_transfer_implement_list_file_transfers (SalutSvcChannelTypeFileTransferClass *klass, salut_svc_channel_type_file_transfer_list_file_transfers_impl impl)
{
  klass->list_file_transfers = impl;
}

/**
 * salut_svc_channel_type_file_transfer_offer_file_impl:
 * @self: The object implementing this interface
 * @in_filename: const gchar * (FIXME, generate documentation)
 * @in_information: GHashTable * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * OfferFile on interface org.freedesktop.Telepathy.Channel.Type.FileTransfer.
 */
static void
salut_svc_channel_type_file_transfer_offer_file (SalutSvcChannelTypeFileTransfer *self,
    const gchar *in_filename,
    GHashTable *in_information,
    DBusGMethodInvocation *context)
{
  salut_svc_channel_type_file_transfer_offer_file_impl impl = (SALUT_SVC_CHANNEL_TYPE_FILE_TRANSFER_GET_CLASS (self)->offer_file);

  if (impl != NULL)
    {
      (impl) (self,
        in_filename,
        in_information,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_channel_type_file_transfer_implement_offer_file:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the OfferFile D-Bus method
 *
 * Register an implementation for the OfferFile method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_channel_type_file_transfer_implement_offer_file (SalutSvcChannelTypeFileTransferClass *klass, salut_svc_channel_type_file_transfer_offer_file_impl impl)
{
  klass->offer_file = impl;
}

/**
 * salut_svc_channel_type_file_transfer_accept_file_impl:
 * @self: The object implementing this interface
 * @in_id: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * AcceptFile on interface org.freedesktop.Telepathy.Channel.Type.FileTransfer.
 */
static void
salut_svc_channel_type_file_transfer_accept_file (SalutSvcChannelTypeFileTransfer *self,
    guint in_id,
    DBusGMethodInvocation *context)
{
  salut_svc_channel_type_file_transfer_accept_file_impl impl = (SALUT_SVC_CHANNEL_TYPE_FILE_TRANSFER_GET_CLASS (self)->accept_file);

  if (impl != NULL)
    {
      (impl) (self,
        in_id,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_channel_type_file_transfer_implement_accept_file:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the AcceptFile D-Bus method
 *
 * Register an implementation for the AcceptFile method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_channel_type_file_transfer_implement_accept_file (SalutSvcChannelTypeFileTransferClass *klass, salut_svc_channel_type_file_transfer_accept_file_impl impl)
{
  klass->accept_file = impl;
}

/**
 * salut_svc_channel_type_file_transfer_close_file_transfer_impl:
 * @self: The object implementing this interface
 * @in_id: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * CloseFileTransfer on interface org.freedesktop.Telepathy.Channel.Type.FileTransfer.
 */
static void
salut_svc_channel_type_file_transfer_close_file_transfer (SalutSvcChannelTypeFileTransfer *self,
    guint in_id,
    DBusGMethodInvocation *context)
{
  salut_svc_channel_type_file_transfer_close_file_transfer_impl impl = (SALUT_SVC_CHANNEL_TYPE_FILE_TRANSFER_GET_CLASS (self)->close_file_transfer);

  if (impl != NULL)
    {
      (impl) (self,
        in_id,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_channel_type_file_transfer_implement_close_file_transfer:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the CloseFileTransfer D-Bus method
 *
 * Register an implementation for the CloseFileTransfer method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_channel_type_file_transfer_implement_close_file_transfer (SalutSvcChannelTypeFileTransferClass *klass, salut_svc_channel_type_file_transfer_close_file_transfer_impl impl)
{
  klass->close_file_transfer = impl;
}

/**
 * salut_svc_channel_type_file_transfer_get_local_unix_socket_path_impl:
 * @self: The object implementing this interface
 * @in_id: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetLocalUnixSocketPath on interface org.freedesktop.Telepathy.Channel.Type.FileTransfer.
 */
static void
salut_svc_channel_type_file_transfer_get_local_unix_socket_path (SalutSvcChannelTypeFileTransfer *self,
    guint in_id,
    DBusGMethodInvocation *context)
{
  salut_svc_channel_type_file_transfer_get_local_unix_socket_path_impl impl = (SALUT_SVC_CHANNEL_TYPE_FILE_TRANSFER_GET_CLASS (self)->get_local_unix_socket_path);

  if (impl != NULL)
    {
      (impl) (self,
        in_id,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_channel_type_file_transfer_implement_get_local_unix_socket_path:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetLocalUnixSocketPath D-Bus method
 *
 * Register an implementation for the GetLocalUnixSocketPath method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_channel_type_file_transfer_implement_get_local_unix_socket_path (SalutSvcChannelTypeFileTransferClass *klass, salut_svc_channel_type_file_transfer_get_local_unix_socket_path_impl impl)
{
  klass->get_local_unix_socket_path = impl;
}

/**
 * salut_svc_channel_type_file_transfer_emit_new_file_transfer:
 * @instance: The object implementing this interface
 * @arg_id: guint  (FIXME, generate documentation)
 * @arg_initiator: guint  (FIXME, generate documentation)
 * @arg_direction: guint  (FIXME, generate documentation)
 * @arg_filename: const gchar * (FIXME, generate documentation)
 * @arg_information: GHashTable * (FIXME, generate documentation)
 * @arg_state: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * NewFileTransfer signal on interface org.freedesktop.Telepathy.Channel.Type.FileTransfer.
 */
void
salut_svc_channel_type_file_transfer_emit_new_file_transfer (gpointer instance,
    guint arg_id,
    guint arg_initiator,
    guint arg_direction,
    const gchar *arg_filename,
    GHashTable *arg_information,
    guint arg_state)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_CHANNEL_TYPE_FILE_TRANSFER));
  g_signal_emit (instance,
      channel_type_file_transfer_signals[SIGNAL_CHANNEL_TYPE_FILE_TRANSFER_NewFileTransfer],
      0,
      arg_id,
      arg_initiator,
      arg_direction,
      arg_filename,
      arg_information,
      arg_state);
}

/**
 * salut_svc_channel_type_file_transfer_emit_file_transfer_state_changed:
 * @instance: The object implementing this interface
 * @arg_id: guint  (FIXME, generate documentation)
 * @arg_state: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * FileTransferStateChanged signal on interface org.freedesktop.Telepathy.Channel.Type.FileTransfer.
 */
void
salut_svc_channel_type_file_transfer_emit_file_transfer_state_changed (gpointer instance,
    guint arg_id,
    guint arg_state)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_CHANNEL_TYPE_FILE_TRANSFER));
  g_signal_emit (instance,
      channel_type_file_transfer_signals[SIGNAL_CHANNEL_TYPE_FILE_TRANSFER_FileTransferStateChanged],
      0,
      arg_id,
      arg_state);
}

/**
 * salut_svc_channel_type_file_transfer_emit_file_transfer_closed:
 * @instance: The object implementing this interface
 * @arg_id: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * FileTransferClosed signal on interface org.freedesktop.Telepathy.Channel.Type.FileTransfer.
 */
void
salut_svc_channel_type_file_transfer_emit_file_transfer_closed (gpointer instance,
    guint arg_id)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_CHANNEL_TYPE_FILE_TRANSFER));
  g_signal_emit (instance,
      channel_type_file_transfer_signals[SIGNAL_CHANNEL_TYPE_FILE_TRANSFER_FileTransferClosed],
      0,
      arg_id);
}

static inline void
salut_svc_channel_type_file_transfer_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Channel.Type.FileTransfer");
  tp_svc_interface_set_dbus_properties_info (SALUT_TYPE_SVC_CHANNEL_TYPE_FILE_TRANSFER, &interface);

  channel_type_file_transfer_signals[SIGNAL_CHANNEL_TYPE_FILE_TRANSFER_NewFileTransfer] =
  g_signal_new ("new-file-transfer",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _salut_ext_marshal_VOID__UINT_UINT_UINT_STRING_BOXED_UINT,
      G_TYPE_NONE,
      6,
      G_TYPE_UINT,
      G_TYPE_UINT,
      G_TYPE_UINT,
      G_TYPE_STRING,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)),
      G_TYPE_UINT);

  channel_type_file_transfer_signals[SIGNAL_CHANNEL_TYPE_FILE_TRANSFER_FileTransferStateChanged] =
  g_signal_new ("file-transfer-state-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _salut_ext_marshal_VOID__UINT_UINT,
      G_TYPE_NONE,
      2,
      G_TYPE_UINT,
      G_TYPE_UINT);

  channel_type_file_transfer_signals[SIGNAL_CHANNEL_TYPE_FILE_TRANSFER_FileTransferClosed] =
  g_signal_new ("file-transfer-closed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__UINT,
      G_TYPE_NONE,
      1,
      G_TYPE_UINT);

  dbus_g_object_type_install_info (salut_svc_channel_type_file_transfer_get_type (),
      &_salut_svc_channel_type_file_transfer_object_info);
}
static void
salut_svc_channel_type_file_transfer_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      salut_svc_channel_type_file_transfer_base_init_once (klass);
    }
}
static const DBusGMethodInfo _salut_svc_channel_type_file_transfer_methods[] = {
  { (GCallback) salut_svc_channel_type_file_transfer_list_file_transfers, g_cclosure_marshal_VOID__POINTER, 0 },
  { (GCallback) salut_svc_channel_type_file_transfer_offer_file, _salut_ext_marshal_VOID__STRING_BOXED_POINTER, 98 },
  { (GCallback) salut_svc_channel_type_file_transfer_accept_file, g_cclosure_marshal_VOID__UINT_POINTER, 209 },
  { (GCallback) salut_svc_channel_type_file_transfer_close_file_transfer, g_cclosure_marshal_VOID__UINT_POINTER, 282 },
  { (GCallback) salut_svc_channel_type_file_transfer_get_local_unix_socket_path, g_cclosure_marshal_VOID__UINT_POINTER, 362 },
};

static const DBusGObjectInfo _salut_svc_channel_type_file_transfer_object_info = {
  0,
  _salut_svc_channel_type_file_transfer_methods,
  5,
"org.freedesktop.Telepathy.Channel.Type.FileTransfer\0ListFileTransfers\0A\0arg0\0O\0F\0N\0a(uuuusa{sv})\0\0org.freedesktop.Telepathy.Channel.Type.FileTransfer\0OfferFile\0A\0filename\0I\0s\0information\0I\0a{sv}\0arg2\0O\0F\0N\0u\0\0org.freedesktop.Telepathy.Channel.Type.FileTransfer\0AcceptFile\0A\0id\0I\0u\0\0org.freedesktop.Telepathy.Channel.Type.FileTransfer\0CloseFileTransfer\0A\0id\0I\0u\0\0org.freedesktop.Telepathy.Channel.Type.FileTransfer\0GetLocalUnixSocketPath\0A\0id\0I\0u\0arg1\0O\0F\0N\0s\0\0\0",
"org.freedesktop.Telepathy.Channel.Type.FileTransfer\0NewFileTransfer\0org.freedesktop.Telepathy.Channel.Type.FileTransfer\0FileTransferStateChanged\0org.freedesktop.Telepathy.Channel.Type.FileTransfer\0FileTransferClosed\0\0",
"\0\0",
};

static const DBusGObjectInfo _salut_svc_olpc_activity_properties_object_info;

struct _SalutSvcOLPCActivityPropertiesClass {
    GTypeInterface parent_class;
    salut_svc_olpc_activity_properties_set_properties_impl set_properties;
    salut_svc_olpc_activity_properties_get_properties_impl get_properties;
};

enum {
    SIGNAL_OLPC_ACTIVITY_PROPERTIES_ActivityPropertiesChanged,
    N_OLPC_ACTIVITY_PROPERTIES_SIGNALS
};
static guint olpc_activity_properties_signals[N_OLPC_ACTIVITY_PROPERTIES_SIGNALS] = {0};

static void salut_svc_olpc_activity_properties_base_init (gpointer klass);

GType
salut_svc_olpc_activity_properties_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (SalutSvcOLPCActivityPropertiesClass),
        salut_svc_olpc_activity_properties_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "SalutSvcOLPCActivityProperties", &info, 0);
    }

  return type;
}

/**
 * salut_svc_olpc_activity_properties_set_properties_impl:
 * @self: The object implementing this interface
 * @in_room: guint  (FIXME, generate documentation)
 * @in_properties: GHashTable * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * SetProperties on interface org.laptop.Telepathy.ActivityProperties.
 */
static void
salut_svc_olpc_activity_properties_set_properties (SalutSvcOLPCActivityProperties *self,
    guint in_room,
    GHashTable *in_properties,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_activity_properties_set_properties_impl impl = (SALUT_SVC_OLPC_ACTIVITY_PROPERTIES_GET_CLASS (self)->set_properties);

  if (impl != NULL)
    {
      (impl) (self,
        in_room,
        in_properties,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_activity_properties_implement_set_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetProperties D-Bus method
 *
 * Register an implementation for the SetProperties method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_activity_properties_implement_set_properties (SalutSvcOLPCActivityPropertiesClass *klass, salut_svc_olpc_activity_properties_set_properties_impl impl)
{
  klass->set_properties = impl;
}

/**
 * salut_svc_olpc_activity_properties_get_properties_impl:
 * @self: The object implementing this interface
 * @in_room: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetProperties on interface org.laptop.Telepathy.ActivityProperties.
 */
static void
salut_svc_olpc_activity_properties_get_properties (SalutSvcOLPCActivityProperties *self,
    guint in_room,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_activity_properties_get_properties_impl impl = (SALUT_SVC_OLPC_ACTIVITY_PROPERTIES_GET_CLASS (self)->get_properties);

  if (impl != NULL)
    {
      (impl) (self,
        in_room,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_activity_properties_implement_get_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetProperties D-Bus method
 *
 * Register an implementation for the GetProperties method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_activity_properties_implement_get_properties (SalutSvcOLPCActivityPropertiesClass *klass, salut_svc_olpc_activity_properties_get_properties_impl impl)
{
  klass->get_properties = impl;
}

/**
 * salut_svc_olpc_activity_properties_emit_activity_properties_changed:
 * @instance: The object implementing this interface
 * @arg_room: guint  (FIXME, generate documentation)
 * @arg_properties: GHashTable * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * ActivityPropertiesChanged signal on interface org.laptop.Telepathy.ActivityProperties.
 */
void
salut_svc_olpc_activity_properties_emit_activity_properties_changed (gpointer instance,
    guint arg_room,
    GHashTable *arg_properties)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES));
  g_signal_emit (instance,
      olpc_activity_properties_signals[SIGNAL_OLPC_ACTIVITY_PROPERTIES_ActivityPropertiesChanged],
      0,
      arg_room,
      arg_properties);
}

static inline void
salut_svc_olpc_activity_properties_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.laptop.Telepathy.ActivityProperties");
  tp_svc_interface_set_dbus_properties_info (SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES, &interface);

  olpc_activity_properties_signals[SIGNAL_OLPC_ACTIVITY_PROPERTIES_ActivityPropertiesChanged] =
  g_signal_new ("activity-properties-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _salut_ext_marshal_VOID__UINT_BOXED,
      G_TYPE_NONE,
      2,
      G_TYPE_UINT,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)));

  dbus_g_object_type_install_info (salut_svc_olpc_activity_properties_get_type (),
      &_salut_svc_olpc_activity_properties_object_info);
}
static void
salut_svc_olpc_activity_properties_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      salut_svc_olpc_activity_properties_base_init_once (klass);
    }
}
static const DBusGMethodInfo _salut_svc_olpc_activity_properties_methods[] = {
  { (GCallback) salut_svc_olpc_activity_properties_set_properties, _salut_ext_marshal_VOID__UINT_BOXED_POINTER, 0 },
  { (GCallback) salut_svc_olpc_activity_properties_get_properties, g_cclosure_marshal_VOID__UINT_POINTER, 85 },
};

static const DBusGObjectInfo _salut_svc_olpc_activity_properties_object_info = {
  0,
  _salut_svc_olpc_activity_properties_methods,
  2,
"org.laptop.Telepathy.ActivityProperties\0SetProperties\0A\0room\0I\0u\0properties\0I\0a{sv}\0\0org.laptop.Telepathy.ActivityProperties\0GetProperties\0A\0room\0I\0u\0properties\0O\0F\0N\0a{sv}\0\0\0",
"org.laptop.Telepathy.ActivityProperties\0ActivityPropertiesChanged\0\0",
"\0\0",
};

static const DBusGObjectInfo _salut_svc_olpc_buddy_info_object_info;

struct _SalutSvcOLPCBuddyInfoClass {
    GTypeInterface parent_class;
    salut_svc_olpc_buddy_info_set_properties_impl set_properties;
    salut_svc_olpc_buddy_info_get_properties_impl get_properties;
    salut_svc_olpc_buddy_info_set_activities_impl set_activities;
    salut_svc_olpc_buddy_info_get_activities_impl get_activities;
    salut_svc_olpc_buddy_info_set_current_activity_impl set_current_activity;
    salut_svc_olpc_buddy_info_get_current_activity_impl get_current_activity;
};

enum {
    SIGNAL_OLPC_BUDDY_INFO_PropertiesChanged,
    SIGNAL_OLPC_BUDDY_INFO_ActivitiesChanged,
    SIGNAL_OLPC_BUDDY_INFO_CurrentActivityChanged,
    N_OLPC_BUDDY_INFO_SIGNALS
};
static guint olpc_buddy_info_signals[N_OLPC_BUDDY_INFO_SIGNALS] = {0};

static void salut_svc_olpc_buddy_info_base_init (gpointer klass);

GType
salut_svc_olpc_buddy_info_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (SalutSvcOLPCBuddyInfoClass),
        salut_svc_olpc_buddy_info_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "SalutSvcOLPCBuddyInfo", &info, 0);
    }

  return type;
}

/**
 * salut_svc_olpc_buddy_info_set_properties_impl:
 * @self: The object implementing this interface
 * @in_properties: GHashTable * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * SetProperties on interface org.laptop.Telepathy.BuddyInfo.
 */
static void
salut_svc_olpc_buddy_info_set_properties (SalutSvcOLPCBuddyInfo *self,
    GHashTable *in_properties,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_buddy_info_set_properties_impl impl = (SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->set_properties);

  if (impl != NULL)
    {
      (impl) (self,
        in_properties,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_buddy_info_implement_set_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetProperties D-Bus method
 *
 * Register an implementation for the SetProperties method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_buddy_info_implement_set_properties (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_properties_impl impl)
{
  klass->set_properties = impl;
}

/**
 * salut_svc_olpc_buddy_info_get_properties_impl:
 * @self: The object implementing this interface
 * @in_contact: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetProperties on interface org.laptop.Telepathy.BuddyInfo.
 */
static void
salut_svc_olpc_buddy_info_get_properties (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_buddy_info_get_properties_impl impl = (SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->get_properties);

  if (impl != NULL)
    {
      (impl) (self,
        in_contact,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_buddy_info_implement_get_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetProperties D-Bus method
 *
 * Register an implementation for the GetProperties method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_buddy_info_implement_get_properties (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_properties_impl impl)
{
  klass->get_properties = impl;
}

/**
 * salut_svc_olpc_buddy_info_set_activities_impl:
 * @self: The object implementing this interface
 * @in_activities: const GPtrArray * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * SetActivities on interface org.laptop.Telepathy.BuddyInfo.
 */
static void
salut_svc_olpc_buddy_info_set_activities (SalutSvcOLPCBuddyInfo *self,
    const GPtrArray *in_activities,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_buddy_info_set_activities_impl impl = (SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->set_activities);

  if (impl != NULL)
    {
      (impl) (self,
        in_activities,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_buddy_info_implement_set_activities:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetActivities D-Bus method
 *
 * Register an implementation for the SetActivities method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_buddy_info_implement_set_activities (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_activities_impl impl)
{
  klass->set_activities = impl;
}

/**
 * salut_svc_olpc_buddy_info_get_activities_impl:
 * @self: The object implementing this interface
 * @in_contact: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetActivities on interface org.laptop.Telepathy.BuddyInfo.
 */
static void
salut_svc_olpc_buddy_info_get_activities (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_buddy_info_get_activities_impl impl = (SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->get_activities);

  if (impl != NULL)
    {
      (impl) (self,
        in_contact,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_buddy_info_implement_get_activities:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetActivities D-Bus method
 *
 * Register an implementation for the GetActivities method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_buddy_info_implement_get_activities (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_activities_impl impl)
{
  klass->get_activities = impl;
}

/**
 * salut_svc_olpc_buddy_info_set_current_activity_impl:
 * @self: The object implementing this interface
 * @in_activity: const gchar * (FIXME, generate documentation)
 * @in_channel: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * SetCurrentActivity on interface org.laptop.Telepathy.BuddyInfo.
 */
static void
salut_svc_olpc_buddy_info_set_current_activity (SalutSvcOLPCBuddyInfo *self,
    const gchar *in_activity,
    guint in_channel,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_buddy_info_set_current_activity_impl impl = (SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->set_current_activity);

  if (impl != NULL)
    {
      (impl) (self,
        in_activity,
        in_channel,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_buddy_info_implement_set_current_activity:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetCurrentActivity D-Bus method
 *
 * Register an implementation for the SetCurrentActivity method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_buddy_info_implement_set_current_activity (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_current_activity_impl impl)
{
  klass->set_current_activity = impl;
}

/**
 * salut_svc_olpc_buddy_info_get_current_activity_impl:
 * @self: The object implementing this interface
 * @in_contact: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetCurrentActivity on interface org.laptop.Telepathy.BuddyInfo.
 */
static void
salut_svc_olpc_buddy_info_get_current_activity (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_buddy_info_get_current_activity_impl impl = (SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->get_current_activity);

  if (impl != NULL)
    {
      (impl) (self,
        in_contact,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_buddy_info_implement_get_current_activity:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetCurrentActivity D-Bus method
 *
 * Register an implementation for the GetCurrentActivity method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_buddy_info_implement_get_current_activity (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_current_activity_impl impl)
{
  klass->get_current_activity = impl;
}

/**
 * salut_svc_olpc_buddy_info_emit_properties_changed:
 * @instance: The object implementing this interface
 * @arg_contact: guint  (FIXME, generate documentation)
 * @arg_properties: GHashTable * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * PropertiesChanged signal on interface org.laptop.Telepathy.BuddyInfo.
 */
void
salut_svc_olpc_buddy_info_emit_properties_changed (gpointer instance,
    guint arg_contact,
    GHashTable *arg_properties)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_OLPC_BUDDY_INFO));
  g_signal_emit (instance,
      olpc_buddy_info_signals[SIGNAL_OLPC_BUDDY_INFO_PropertiesChanged],
      0,
      arg_contact,
      arg_properties);
}

/**
 * salut_svc_olpc_buddy_info_emit_activities_changed:
 * @instance: The object implementing this interface
 * @arg_contact: guint  (FIXME, generate documentation)
 * @arg_activities: const GPtrArray * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * ActivitiesChanged signal on interface org.laptop.Telepathy.BuddyInfo.
 */
void
salut_svc_olpc_buddy_info_emit_activities_changed (gpointer instance,
    guint arg_contact,
    const GPtrArray *arg_activities)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_OLPC_BUDDY_INFO));
  g_signal_emit (instance,
      olpc_buddy_info_signals[SIGNAL_OLPC_BUDDY_INFO_ActivitiesChanged],
      0,
      arg_contact,
      arg_activities);
}

/**
 * salut_svc_olpc_buddy_info_emit_current_activity_changed:
 * @instance: The object implementing this interface
 * @arg_contact: guint  (FIXME, generate documentation)
 * @arg_activity: const gchar * (FIXME, generate documentation)
 * @arg_channel: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * CurrentActivityChanged signal on interface org.laptop.Telepathy.BuddyInfo.
 */
void
salut_svc_olpc_buddy_info_emit_current_activity_changed (gpointer instance,
    guint arg_contact,
    const gchar *arg_activity,
    guint arg_channel)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_OLPC_BUDDY_INFO));
  g_signal_emit (instance,
      olpc_buddy_info_signals[SIGNAL_OLPC_BUDDY_INFO_CurrentActivityChanged],
      0,
      arg_contact,
      arg_activity,
      arg_channel);
}

static inline void
salut_svc_olpc_buddy_info_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.laptop.Telepathy.BuddyInfo");
  tp_svc_interface_set_dbus_properties_info (SALUT_TYPE_SVC_OLPC_BUDDY_INFO, &interface);

  olpc_buddy_info_signals[SIGNAL_OLPC_BUDDY_INFO_PropertiesChanged] =
  g_signal_new ("properties-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _salut_ext_marshal_VOID__UINT_BOXED,
      G_TYPE_NONE,
      2,
      G_TYPE_UINT,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)));

  olpc_buddy_info_signals[SIGNAL_OLPC_BUDDY_INFO_ActivitiesChanged] =
  g_signal_new ("activities-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _salut_ext_marshal_VOID__UINT_BOXED,
      G_TYPE_NONE,
      2,
      G_TYPE_UINT,
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_STRING, G_TYPE_UINT, G_TYPE_INVALID)))));

  olpc_buddy_info_signals[SIGNAL_OLPC_BUDDY_INFO_CurrentActivityChanged] =
  g_signal_new ("current-activity-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _salut_ext_marshal_VOID__UINT_STRING_UINT,
      G_TYPE_NONE,
      3,
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_UINT);

  dbus_g_object_type_install_info (salut_svc_olpc_buddy_info_get_type (),
      &_salut_svc_olpc_buddy_info_object_info);
}
static void
salut_svc_olpc_buddy_info_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      salut_svc_olpc_buddy_info_base_init_once (klass);
    }
}
static const DBusGMethodInfo _salut_svc_olpc_buddy_info_methods[] = {
  { (GCallback) salut_svc_olpc_buddy_info_set_properties, _salut_ext_marshal_VOID__BOXED_POINTER, 0 },
  { (GCallback) salut_svc_olpc_buddy_info_get_properties, g_cclosure_marshal_VOID__UINT_POINTER, 67 },
  { (GCallback) salut_svc_olpc_buddy_info_set_activities, _salut_ext_marshal_VOID__BOXED_POINTER, 150 },
  { (GCallback) salut_svc_olpc_buddy_info_get_activities, g_cclosure_marshal_VOID__UINT_POINTER, 217 },
  { (GCallback) salut_svc_olpc_buddy_info_set_current_activity, _salut_ext_marshal_VOID__STRING_UINT_POINTER, 300 },
  { (GCallback) salut_svc_olpc_buddy_info_get_current_activity, g_cclosure_marshal_VOID__UINT_POINTER, 378 },
};

static const DBusGObjectInfo _salut_svc_olpc_buddy_info_object_info = {
  0,
  _salut_svc_olpc_buddy_info_methods,
  6,
"org.laptop.Telepathy.BuddyInfo\0SetProperties\0A\0properties\0I\0a{sv}\0\0org.laptop.Telepathy.BuddyInfo\0GetProperties\0A\0contact\0I\0u\0properties\0O\0F\0N\0a{sv}\0\0org.laptop.Telepathy.BuddyInfo\0SetActivities\0A\0activities\0I\0a(su)\0\0org.laptop.Telepathy.BuddyInfo\0GetActivities\0A\0contact\0I\0u\0activities\0O\0F\0N\0a(su)\0\0org.laptop.Telepathy.BuddyInfo\0SetCurrentActivity\0A\0activity\0I\0s\0channel\0I\0u\0\0org.laptop.Telepathy.BuddyInfo\0GetCurrentActivity\0A\0contact\0I\0u\0activity\0O\0F\0N\0s\0channel\0O\0F\0N\0u\0\0\0",
"org.laptop.Telepathy.BuddyInfo\0PropertiesChanged\0org.laptop.Telepathy.BuddyInfo\0ActivitiesChanged\0org.laptop.Telepathy.BuddyInfo\0CurrentActivityChanged\0\0",
"\0\0",
};


