#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * SalutSvcChannelTypeFileTransfer:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SalutSvcChannelTypeFileTransfer SalutSvcChannelTypeFileTransfer;

/**
 * SalutSvcChannelTypeFileTransferClass:
 *
 * The class of SalutSvcChannelTypeFileTransfer.
 */
typedef struct _SalutSvcChannelTypeFileTransferClass SalutSvcChannelTypeFileTransferClass;

GType salut_svc_channel_type_file_transfer_get_type (void);
#define SALUT_TYPE_SVC_CHANNEL_TYPE_FILE_TRANSFER \
  (salut_svc_channel_type_file_transfer_get_type ())
#define SALUT_SVC_CHANNEL_TYPE_FILE_TRANSFER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SALUT_TYPE_SVC_CHANNEL_TYPE_FILE_TRANSFER, SalutSvcChannelTypeFileTransfer))
#define SALUT_IS_SVC_CHANNEL_TYPE_FILE_TRANSFER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SALUT_TYPE_SVC_CHANNEL_TYPE_FILE_TRANSFER))
#define SALUT_SVC_CHANNEL_TYPE_FILE_TRANSFER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SALUT_TYPE_SVC_CHANNEL_TYPE_FILE_TRANSFER, SalutSvcChannelTypeFileTransferClass))


typedef void (*salut_svc_channel_type_file_transfer_list_file_transfers_impl) (SalutSvcChannelTypeFileTransfer *self,
    DBusGMethodInvocation *context);
void salut_svc_channel_type_file_transfer_implement_list_file_transfers (SalutSvcChannelTypeFileTransferClass *klass, salut_svc_channel_type_file_transfer_list_file_transfers_impl impl);
/**
 * salut_svc_channel_type_file_transfer_return_from_list_file_transfers:
 * @context: The D-Bus method invocation context
 * @out0: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_channel_type_file_transfer_return_from_list_file_transfers (DBusGMethodInvocation *context,
    const GPtrArray *out0);
static inline void
salut_svc_channel_type_file_transfer_return_from_list_file_transfers (DBusGMethodInvocation *context,
    const GPtrArray *out0)
{
  dbus_g_method_return (context,
      out0);
}

typedef void (*salut_svc_channel_type_file_transfer_offer_file_impl) (SalutSvcChannelTypeFileTransfer *self,
    const gchar *in_filename,
    GHashTable *in_information,
    DBusGMethodInvocation *context);
void salut_svc_channel_type_file_transfer_implement_offer_file (SalutSvcChannelTypeFileTransferClass *klass, salut_svc_channel_type_file_transfer_offer_file_impl impl);
/**
 * salut_svc_channel_type_file_transfer_return_from_offer_file:
 * @context: The D-Bus method invocation context
 * @out0: guint  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_channel_type_file_transfer_return_from_offer_file (DBusGMethodInvocation *context,
    guint out0);
static inline void
salut_svc_channel_type_file_transfer_return_from_offer_file (DBusGMethodInvocation *context,
    guint out0)
{
  dbus_g_method_return (context,
      out0);
}

typedef void (*salut_svc_channel_type_file_transfer_accept_file_impl) (SalutSvcChannelTypeFileTransfer *self,
    guint in_id,
    DBusGMethodInvocation *context);
void salut_svc_channel_type_file_transfer_implement_accept_file (SalutSvcChannelTypeFileTransferClass *klass, salut_svc_channel_type_file_transfer_accept_file_impl impl);
/**
 * salut_svc_channel_type_file_transfer_return_from_accept_file:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_channel_type_file_transfer_return_from_accept_file (DBusGMethodInvocation *context);
static inline void
salut_svc_channel_type_file_transfer_return_from_accept_file (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_channel_type_file_transfer_close_file_transfer_impl) (SalutSvcChannelTypeFileTransfer *self,
    guint in_id,
    DBusGMethodInvocation *context);
void salut_svc_channel_type_file_transfer_implement_close_file_transfer (SalutSvcChannelTypeFileTransferClass *klass, salut_svc_channel_type_file_transfer_close_file_transfer_impl impl);
/**
 * salut_svc_channel_type_file_transfer_return_from_close_file_transfer:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_channel_type_file_transfer_return_from_close_file_transfer (DBusGMethodInvocation *context);
static inline void
salut_svc_channel_type_file_transfer_return_from_close_file_transfer (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_channel_type_file_transfer_get_local_unix_socket_path_impl) (SalutSvcChannelTypeFileTransfer *self,
    guint in_id,
    DBusGMethodInvocation *context);
void salut_svc_channel_type_file_transfer_implement_get_local_unix_socket_path (SalutSvcChannelTypeFileTransferClass *klass, salut_svc_channel_type_file_transfer_get_local_unix_socket_path_impl impl);
/**
 * salut_svc_channel_type_file_transfer_return_from_get_local_unix_socket_path:
 * @context: The D-Bus method invocation context
 * @out0: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_channel_type_file_transfer_return_from_get_local_unix_socket_path (DBusGMethodInvocation *context,
    const gchar *out0);
static inline void
salut_svc_channel_type_file_transfer_return_from_get_local_unix_socket_path (DBusGMethodInvocation *context,
    const gchar *out0)
{
  dbus_g_method_return (context,
      out0);
}

void salut_svc_channel_type_file_transfer_emit_new_file_transfer (gpointer instance,
    guint arg_id,
    guint arg_initiator,
    guint arg_direction,
    const gchar *arg_filename,
    GHashTable *arg_information,
    guint arg_state);
void salut_svc_channel_type_file_transfer_emit_file_transfer_state_changed (gpointer instance,
    guint arg_id,
    guint arg_state);
void salut_svc_channel_type_file_transfer_emit_file_transfer_closed (gpointer instance,
    guint arg_id);

/**
 * SalutSvcOLPCActivityProperties:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SalutSvcOLPCActivityProperties SalutSvcOLPCActivityProperties;

/**
 * SalutSvcOLPCActivityPropertiesClass:
 *
 * The class of SalutSvcOLPCActivityProperties.
 */
typedef struct _SalutSvcOLPCActivityPropertiesClass SalutSvcOLPCActivityPropertiesClass;

GType salut_svc_olpc_activity_properties_get_type (void);
#define SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES \
  (salut_svc_olpc_activity_properties_get_type ())
#define SALUT_SVC_OLPC_ACTIVITY_PROPERTIES(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES, SalutSvcOLPCActivityProperties))
#define SALUT_IS_SVC_OLPC_ACTIVITY_PROPERTIES(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES))
#define SALUT_SVC_OLPC_ACTIVITY_PROPERTIES_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES, SalutSvcOLPCActivityPropertiesClass))


typedef void (*salut_svc_olpc_activity_properties_set_properties_impl) (SalutSvcOLPCActivityProperties *self,
    guint in_room,
    GHashTable *in_properties,
    DBusGMethodInvocation *context);
void salut_svc_olpc_activity_properties_implement_set_properties (SalutSvcOLPCActivityPropertiesClass *klass, salut_svc_olpc_activity_properties_set_properties_impl impl);
/**
 * salut_svc_olpc_activity_properties_return_from_set_properties:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_activity_properties_return_from_set_properties (DBusGMethodInvocation *context);
static inline void
salut_svc_olpc_activity_properties_return_from_set_properties (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_olpc_activity_properties_get_properties_impl) (SalutSvcOLPCActivityProperties *self,
    guint in_room,
    DBusGMethodInvocation *context);
void salut_svc_olpc_activity_properties_implement_get_properties (SalutSvcOLPCActivityPropertiesClass *klass, salut_svc_olpc_activity_properties_get_properties_impl impl);
/**
 * salut_svc_olpc_activity_properties_return_from_get_properties:
 * @context: The D-Bus method invocation context
 * @out_properties: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_activity_properties_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties);
static inline void
salut_svc_olpc_activity_properties_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties)
{
  dbus_g_method_return (context,
      out_properties);
}

void salut_svc_olpc_activity_properties_emit_activity_properties_changed (gpointer instance,
    guint arg_room,
    GHashTable *arg_properties);

/**
 * SalutSvcOLPCBuddyInfo:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SalutSvcOLPCBuddyInfo SalutSvcOLPCBuddyInfo;

/**
 * SalutSvcOLPCBuddyInfoClass:
 *
 * The class of SalutSvcOLPCBuddyInfo.
 */
typedef struct _SalutSvcOLPCBuddyInfoClass SalutSvcOLPCBuddyInfoClass;

GType salut_svc_olpc_buddy_info_get_type (void);
#define SALUT_TYPE_SVC_OLPC_BUDDY_INFO \
  (salut_svc_olpc_buddy_info_get_type ())
#define SALUT_SVC_OLPC_BUDDY_INFO(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SALUT_TYPE_SVC_OLPC_BUDDY_INFO, SalutSvcOLPCBuddyInfo))
#define SALUT_IS_SVC_OLPC_BUDDY_INFO(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SALUT_TYPE_SVC_OLPC_BUDDY_INFO))
#define SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SALUT_TYPE_SVC_OLPC_BUDDY_INFO, SalutSvcOLPCBuddyInfoClass))


typedef void (*salut_svc_olpc_buddy_info_set_properties_impl) (SalutSvcOLPCBuddyInfo *self,
    GHashTable *in_properties,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_set_properties (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_properties_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_set_properties:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_set_properties (DBusGMethodInvocation *context);
static inline void
salut_svc_olpc_buddy_info_return_from_set_properties (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_olpc_buddy_info_get_properties_impl) (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_get_properties (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_properties_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_get_properties:
 * @context: The D-Bus method invocation context
 * @out_properties: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties);
static inline void
salut_svc_olpc_buddy_info_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties)
{
  dbus_g_method_return (context,
      out_properties);
}

typedef void (*salut_svc_olpc_buddy_info_set_activities_impl) (SalutSvcOLPCBuddyInfo *self,
    const GPtrArray *in_activities,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_set_activities (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_activities_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_set_activities:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_set_activities (DBusGMethodInvocation *context);
static inline void
salut_svc_olpc_buddy_info_return_from_set_activities (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_olpc_buddy_info_get_activities_impl) (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_get_activities (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_activities_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_get_activities:
 * @context: The D-Bus method invocation context
 * @out_activities: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_get_activities (DBusGMethodInvocation *context,
    const GPtrArray *out_activities);
static inline void
salut_svc_olpc_buddy_info_return_from_get_activities (DBusGMethodInvocation *context,
    const GPtrArray *out_activities)
{
  dbus_g_method_return (context,
      out_activities);
}

typedef void (*salut_svc_olpc_buddy_info_set_current_activity_impl) (SalutSvcOLPCBuddyInfo *self,
    const gchar *in_activity,
    guint in_channel,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_set_current_activity (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_current_activity_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_set_current_activity:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_set_current_activity (DBusGMethodInvocation *context);
static inline void
salut_svc_olpc_buddy_info_return_from_set_current_activity (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_olpc_buddy_info_get_current_activity_impl) (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_get_current_activity (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_current_activity_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_get_current_activity:
 * @context: The D-Bus method invocation context
 * @out_activity: const gchar * (FIXME, generate documentation)
 * @out_channel: guint  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_get_current_activity (DBusGMethodInvocation *context,
    const gchar *out_activity,
    guint out_channel);
static inline void
salut_svc_olpc_buddy_info_return_from_get_current_activity (DBusGMethodInvocation *context,
    const gchar *out_activity,
    guint out_channel)
{
  dbus_g_method_return (context,
      out_activity,
      out_channel);
}

void salut_svc_olpc_buddy_info_emit_properties_changed (gpointer instance,
    guint arg_contact,
    GHashTable *arg_properties);
void salut_svc_olpc_buddy_info_emit_activities_changed (gpointer instance,
    guint arg_contact,
    const GPtrArray *arg_activities);
void salut_svc_olpc_buddy_info_emit_current_activity_changed (gpointer instance,
    guint arg_contact,
    const gchar *arg_activity,
    guint arg_channel);


G_END_DECLS
